#pragma once

#include "AbstractVisualNode.h"

#include "ElectronicCircuit.h"

class WireNode;
class TerminalNode;
class LogicGateNode;

class ElectronicCircuitNode : public AbstractVisualNode
{
public:
    ElectronicCircuitNode(const Transform& transform);

    virtual ~ElectronicCircuitNode();

    void setContent(ElectronicCircuit* content);

    void update(SceneInfo* sceneInfo);

private:
    void createOrUpdateGeometry(SceneInfo* sceneInfo);

    ElectronicCircuit* mContent{ nullptr };
    bool mContentDirty{ true };

    std::vector<std::unique_ptr<TerminalNode> > mInputTerminalNodes;
    std::vector<std::unique_ptr<WireNode> > mWireNodes;
    std::vector<std::unique_ptr<LogicGateNode> > mLogicGateNodes;
};
