#pragma once

#include "AbstractVisualNode.h"

#include "CircleNode.h"

class LogicGate;
class PathNode;

class LogicGateNode : public AbstractVisualNode
{
public:
    LogicGateNode(const Transform& transform);

    virtual ~LogicGateNode();

    void setContent(LogicGate* content);

    void update(SceneInfo* sceneInfo);
private:
    void createOrUpdateGeometry(SceneInfo* sceneInfo);

    LogicGate* mContent{ nullptr };
    bool mContentDirty{ true };

    std::unique_ptr<PathNode> mPrimaryPath;
    std::unique_ptr<CircleNode> mNegationGlyph;
};
